<?php

/***
 * 
 * k.Bot - modular irc bot
 * Copyright (C) 2004 Kore Nordmann - http://www.kore-nordmann.de (German)
 * 
 * This program is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; either version 2 of the License, or (at 
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software Foundation, 
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
 * 
 * You may contact the author by mail:
 * kbot@kore-nordmann.de
 *
 * Or write to:
 * Kore Nordmann
 * Stockumer Strasse 404
 * 44227 Dortmund
 * Germany
 *
 * The latest version of k.Bot can be obtained from:
 * http://www.kore-nordmann.de/
 *
 **/

if (isset($_GET['cid']) && isset($_GET['chid'])) {
	// Installieren eines Commandos
	$db->insert('access', array(	'command_id' =>	intval($_GET['cid']),
									'channel_id' =>	intval($_GET['chid']),
									'level' =>		0));
}

if (@$_POST['form'] == 'go') {
	$level = (int) $_POST['status'];
	if ($level == -1) {
		// Deinstallieren eines Kommandos
		$db->query('DELETE FROM access WHERE command_id = ' . intval($_POST['cid']) . ' AND channel_id = ' . intval($_POST['chid']));
	} else {
		// Rechte eines Kommandos updaten
		$db->update('access', array('level' => $level), 'command_id = ' . intval($_POST['cid']) . ' AND channel_id = ' . intval($_POST['chid']));
	}
}

if (!isset($_SESSION['bot'])) {
	echo "<p>Erst einen Bot ausw&auml;hlen.</p>\n";
} else {
	
	// Alle Channel einlesen
	$channel = array();
	$db->query('SELECT id, name FROM channel WHERE bot_id = ' . $_SESSION['bot'] . ' ORDER BY name');
	while ($db->isNext()) {
		$row = $db->getNext();
		$channel[(int) $row['id']] = $row['name'];
	}
	
	// Was ist wo installiert
	if ($db->query('
		SELECT 
			c.type, 
			c.command,
			c.descr,
			c.id AS cid,
			ch.id AS chid,
			MIN(a.level) AS status
		FROM 
			command AS c
		LEFT JOIN
			access AS a
		ON
			a.command_id = c.id
		LEFT JOIN
			channel AS ch
		ON
				ch.id = a.channel_id
			AND ch.bot_id = ' . $_SESSION['bot'] . '
		GROUP BY
			cid,
			chid
		ORDER BY
			type,
			command
	')) {
		$commands = array();
		$install = array();
	
		// Auslesen der Daten
		while ($db->isNext()) {
			$row = $db->getNext();
			
			switch($row['type']) {
				case 'text':
					$command = 'onText';
				break;
				case 'action':
					$command = 'on' . ucfirst($row['command']);
				break;
				case 'command':
					$command = '!' . $row['command'];
				break;
			}
			
			$commands[(int) $row['cid']] = array($command, $row['descr']);
			if ($row['chid'] != NULL) {
				$install[(int) $row['chid']][(int) $row['cid']] = (int) $row['status'];
			}
		}
		
		// Farben und Aliase fuer die Status festlegen
		$status = array(-1 => 'uninstall', 0 => 'none', 1 => 'voice', 2 => 'halfop', 4 => 'op', 8 => 'admin', 16 => 'founder');
		$color = array(-1 => '#FF0000', 0 => '#000000', 1 => '#00FF00', 2 => '#42C000', 4 => '#818100', 8 => '#C04200', 16 => '#FF0000');

		// Ausgabe
		echo "<p>Hier k&ouml;nnen die einzelnen Befehle f&uuml;r einen Channel installiert werden. &quot;none&quot; bedeutet uneingeschr&auml;nkten Zugang fuer alle, w&auml;hrend die weiteren Modi den minimal ben&ouml;tigten Status f&uuml;r einen Befehl festlegen.</p><table>\n<tr>\n\t<th style=\"width: 100px;\">x</th>\n";
		foreach ($channel as $c) echo "\t<th style=\"font-size: 10px;\">$c</th>\n";
		echo "</tr>\n";
		
		foreach ($commands as $cid => $command) {
			echo "<tr>\n";
			echo "\t<th style=\"font-size: 10px;\" title=\"" . $command[1] . "\">" . $command[0] . "</th>\n";

			foreach ($channel as $chid => $c) {
				if (isset($install[(int) $chid][(int) $cid])) {
					echo "\t<td style=\"text-align: center;\">\n";
					echo "\t\t<form action=\"$self\" method=\"post\">\n";
					echo "\t\t\t<input type=\"hidden\" name=\"cid\" value=\"$cid\" />\n";
					echo "\t\t\t<input type=\"hidden\" name=\"chid\" value=\"$chid\" />\n";
					echo "\t\t\t<select name=\"status\" style=\"color: " . $color[$install[(int) $chid][(int) $cid]] . ";\">\n";
					foreach ($status as $lvl => $name) {
						printf("\t\t\t\t<option value=\"%d\" style=\"color: %s;\" %s>%s</option>\n",
								$lvl,
								$color[$lvl],
								($lvl == (int) $install[(int) $chid][(int) $cid] ? 'selected' : ''),
								$name);
					}
					echo "\t\t\t</select>\n";
					echo "\t\t\t<input type=\"submit\" name=\"form\" value=\"go\" style=\"\" />\n";
					echo "\t\t</form>\n";
					echo "\t</td>\n";
				} else {
					echo "\t<td style=\"text-align: center;\"><a href=\"$self&amp;cid=$cid&amp;chid=$chid\" >[install]</a></td>\n";
				}
			}
			echo "</tr>\n";
		}
		echo "</table>\n";
	} else {
		echo "<p>Keine Kommandos installiert.</p>\n";
	}
}

?>