<?php

/***
 * 
 * k.Bot - modular irc bot
 * Copyright (C) 2004 Kore Nordmann - http://www.kore-nordmann.de (German)
 * 
 * This program is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; either version 2 of the License, or (at 
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software Foundation, 
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
 * 
 * You may contact the author by mail:
 * kbot@kore-nordmann.de
 *
 * Or write to:
 * Kore Nordmann
 * Stockumer Strasse 404
 * 44227 Dortmund
 * Germany
 *
 * The latest version of k.Bot can be obtained from:
 * http://www.kore-nordmann.de/
 *
 **/

// Wandelt Masken in Reguelaere-Ausdruecke um (POSIX fuer MySQL)
function mask2regexp($mask) {
	$mask = str_replace(array(	'\\?',
								'\\*'),
						array(	'.?',
								'.*'),
						preg_quote($mask));
	return '^' . $mask . '$';
}

// Wandelt regulaere Ausdruecke wieder in Masken um
function regexp2mask($regexp) {
	$mask = str_replace(array(	'.?',
								'.*'),
						array(	'?',
								'*'),
						stripslashes($regexp));
	return substr($mask, 1, -1);
}

// Neuen Benutzer einfuegen
if (isset($_POST['new_user'])) {
	$db->insert('user_access', array('mask' => mask2regexp($_POST['mask']), 'password' => md5($_POST['password'])));
}

// Benutzer loeschen
if (isset($_GET['uid'])) {
	$db->query('DELETE FROM user_access WHERE id = ' . intval($_GET['uid']));
}

// Passwortaenderung uebernehmen
if (@is_array($_POST['password'])) {
	foreach ($_POST['password'] as $id => $newpw) {
		$db->update('user_access', array('password' => md5($newpw)), 'id = ' . intval($id));
	}
}

// Anederung der maske uebernehmen
if (@is_array($_POST['mask'])) {
	foreach ($_POST['mask'] as $id => $mask) {
		$db->update('user_access', array('mask' => mask2regexp($mask)), 'id = ' . intval($id));
	}
}

// Ausgabe
if ($db->query('SELECT id, mask FROM user_access')) {
	echo "<table>\n";
	echo "<tr><th>Mask</th><th>Passwort</th><th>Optionen</th></tr>\n";
	while ($db->isNext()) {
		$user = $db->getNext();
		printf("<tr><td><form action=\"%s\" method=\"post\"><input type=\"text\" name=\"mask[%d]\" value=\"%s\" /><button type=\"submit\" style=\"display: none;\" /></form></td><td><form action=\"%s\" method=\"post\"><input type=\"password\" name=\"password[%d]\" /><button type=\"submit\" style=\"display: none;\" /></form></td><td style=\"text-align: center;\"><a href=\"%s&amp;uid=%s\"><img src=\"icons/0.png\" alt=\"Loeschen\" title=\"Loeschen\" /></a></td></tr>\n", 
				$self,
				$user['id'],
				regexp2mask($user['mask']),
				$self,
				$user['id'],
				$self,
				$user['id']);
	}
	echo "</table>\n";
} else {
	echo "Bisher keine Beuntzer eingef&uuml;gt.";
}

?>
<p>Einen neuen Benutzer einf&uuml;gen:
<form action="<?php echo $self; ?>" method="post">
	<p>Mask: <input type="text" name="mask" value="*!*ident@*" /></p>
	<p>Passwort: <input type="password" name="password" value="" /></p>
	<p><input type="submit" name="new_user" value="Erstellen" /></p>
</form>
</p>