<?php

/***
 * 
 * k.Bot - modular irc bot
 * Copyright (C) 2004 Kore Nordmann - http://www.kore-nordmann.de (German)
 * 
 * This program is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; either version 2 of the License, or (at 
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software Foundation, 
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
 * 
 * You may contact the author by mail:
 * kbot@kore-nordmann.de
 *
 * Or write to:
 * Kore Nordmann
 * Stockumer Strasse 404
 * 44227 Dortmund
 * Germany
 *
 * The latest version of k.Bot can be obtained from:
 * http://www.kore-nordmann.de/
 *
 **/
 
/**
 * Wetterinformationen von donenrwetter.de
 */

// Installationsanweisungen fuer den Bot
if (isset($_GET['install'])) {
	echo "command:wetterheute(Prognose fuer das heutige Wetter)\n";
	echo "command:wettermorgen(Prognose fuer das Wetter in den naechsten Tagen)\n";
	echo "command:wetter(Alias fuer 'wettermorgen')\n";
	echo "command:wettertrend(Wetterprognose fuer die naechste Woche.)\n";
	die();
}

// Ermitteln der Ortskennzahl
if (empty($_GET['text'])) die("msg:" . $_GET['output'] . "(Bitte einen Ort oder eine Postleitzahl angeben.)\n");

// Mysql-Klasse einbinden und Objekt erstellen
require_once(dirname(__FILE__) . '/../classes/mysql.php');
$mysql = new mysql();

if ($mysql->query('SELECT kennzahl FROM mod_wetter WHERE name = \'' . mysql_escape_string($_GET['text']) . "'")) {
	// Ort schon in der Datenbank
	$region = $mysql->getSingle();
} else {
	// Ermitteln der Kennzahl ueber die Seitensuche
	$site = file_get_contents('http://www.donnerwetter.de/region/suchort.mv?x=0&y=0&search=' . urlencode($_GET['text']));
	$search = '/region/region.hts?';
	if ($pos = strpos($site, $search)) {
		$region = substr($site, $pos + strlen($search), strpos(substr($site, $pos + strlen($search)), '"'));
		$mysql->insert('mod_wetter', array('name' => $_GET['text'], 'kennzahl' => $region));
	} else {
		die("msg:" . $_GET['output'] . "(Keinen Ort mit angegebenem Namen gefunden.)\n");
	}
}

$text = '';
$name = substr($region, strrpos($region, '+') + 1);

switch ($_GET['command']) {
	case 'wetterheute':
		$site = file_get_contents('http://www.donnerwetter.de/region/region.hts?' . $region);
		preg_match_all('/<td\s*width="421"\s*>\s*<table\s*width="418".*<td>(.*)<\/td\s*>/Uims', $site, $matches);
		for ($i = 0; $i < count($matches[0]); $i++) {
			$text .= html_entity_decode(trim($matches[1][$i]));
		}
		if ($i === 0) die("msg:" . $_GET['output'] . "(Fehler beim Auslesen.)\n");
		printf("msg:%s(Das Wetter heute in %s: %s)\n", $_GET['output'], $name, $text);
	break;
	case 'wetter':
	case 'wettermorgen':
		$site = file_get_contents('http://www.donnerwetter.de/region/morgen.hts?' . $region);
		preg_match_all('/<td\s*width="421"\s*>\s*<table\s*width="418".*<td>(.*)<\/td\s*>/Uims', $site, $matches);
		for ($i = 0; $i < count($matches[0]); $i++) {
			$text .= html_entity_decode(trim($matches[1][$i]));
		}
		if ($i === 0) die("msg:" . $_GET['output'] . "(Fehler beim Auslesen.)\n");
		printf("msg:%s(Wettervorhersage fuer %s: %s)\n", $_GET['output'], $name, $text);
	break;
	case 'wettertrend':
		$site = file_get_contents('http://www.donnerwetter.de/region/mittelfrist.hts?' . $region);
		preg_match_all('/<td\s*width="421"\s*>\s*<table\s*width="418".*<td>.*<\/strong.*>(.*)<\/td\s*>/Uims', $site, $matches);
		for ($i = 0; $i < count($matches[0]); $i++) {
			$text .= html_entity_decode(trim(strip_tags($matches[1][$i])));
		}
		if ($i === 0) die("msg:" . $_GET['output'] . "(Fehler beim Auslesen.)\n");
		printf("msg:%s(Der Wettertrend in %s: %s)\n", $_GET['output'], $name, $text);
	break;
}

?>